﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Media.Animation;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace Sample
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        private bool _bLogin = true;
        private Storyboard sbRegister;
        private Storyboard sbLogin;

        public MainPage()
        {
            this.InitializeComponent();
            initGrid();
            TransitionAnimation();
        }

        /// <summary>
        /// Invoked when this page is about to be displayed in a Frame.
        /// </summary>
        /// <param name="e">Event data that describes how this page was reached.  The Parameter
        /// property is typically used to configure the page.</param>
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
        }

        private void TransitionAnimation()
        {
            DoubleAnimation daRegister = new DoubleAnimation(); 
            daRegister.From = -gMain.Width / 2.0; ;
            daRegister.To = 0.0;
            daRegister.Duration = new Duration(TimeSpan.FromMilliseconds(300));
            daRegister.AutoReverse = false;
            Storyboard.SetTarget(daRegister, gMain);
            Storyboard.SetTargetProperty(daRegister, "(Canvas.Left)");
            sbRegister = new Storyboard();
            sbRegister.Children.Add(daRegister);

            DoubleAnimation daLogin = new DoubleAnimation();
            daLogin.From = 0.0;
            daLogin.To = -gMain.Width / 2.0;
            daLogin.Duration = new Duration(TimeSpan.FromMilliseconds(300));
            daLogin.AutoReverse = false;
            Storyboard.SetTarget(daLogin, gMain);
            Storyboard.SetTargetProperty(daLogin, "(Canvas.Left)");
            sbLogin = new Storyboard();
            sbLogin.Children.Add(daLogin);
        }

        private void Canvas_Tapped(object sender, TappedRoutedEventArgs e)
        {
            Move(this.TransformToVisual(ucLogin).TransformPoint(e.GetPosition(this)).X, this.TransformToVisual(ucRegister).TransformPoint(e.GetPosition(this)).X);
        }

        private void Move(double ucLoginX, double ucRegisterX)
        {
            if (ucLoginX >= 0 && ucLoginX <= ucLogin.Width)
            {
                if (!_bLogin)
                {
                    sbRegister.Begin();
                    _bLogin = true;
                }
            }
            else if (ucRegisterX >= 0 && ucRegisterX <= ucRegister.Width)
            {
                if (_bLogin)
                {
                    sbLogin.Begin();
                    _bLogin = false;
                }
            }

            setUCState(_bLogin);
        }

        private void setUCState(bool bLogin = true)
        {
            if (bLogin)
            {
                ucLogin.IsEnabled = true;
                ucRegister.IsEnabled = false;
            }
            else
            {
                ucLogin.IsEnabled = false;
                ucRegister.IsEnabled = true;
            }
        }

        private void initGrid()
        {
            gMain.Width = Window.Current.CoreWindow.Bounds.Width;
            gMain.Height = Window.Current.CoreWindow.Bounds.Height;

            setUCState();
        }
    }
}
